VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPickFolderDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 02/2021

Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const CC_STDCALL As Long = &H4&
Private Const IID_Release As Long = &H8&
Private Const CLSCTX_INPROC As Long = &H1&
Private Const CLSID_FileOpenDialog As String = "{DC1C5A9C-E88A-4DDE-A5A1-60F82A20AEF7}"
Private Const IID_IFileDialog2 As String = "{61744FC7-85B5-4791-A9B0-272276309B13}"
Private Const IID_IShellItem As String = "{43826D1E-E718-42EE-BC55-A1E261C37BFE}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IModalWindow
    Show_ = 3
    
    ' IFileDialog
    SetFileTypes_ = 4
    SetFileTypeIndex_ = 5
    GetFileTypeIndex_ = 6
    Advise_ = 7
    Unadvise_ = 8
    SetOptions_ = 9
    GetOptions_ = 10
    SetDefaultFolder_ = 11
    SetFolder_ = 12
    GetFolder_ = 13
    GetCurrentSelection_ = 14
    SetFileName_ = 15
    GetFileName_ = 16
    SetTitle_ = 17
    SetOkButtonLabel_ = 18
    SetFileNameLabel_ = 19
    GetResult_ = 20
    AddPlace_ = 21
    SetDefaultExtension_ = 22
    Close_ = 23
    SetClientGuid_ = 24
    ClearClientData_ = 25
    SetFilter_ = 26
    
    ' IFileDialog2
    SetCancelButtonLabel_ = 27
    SetNavigationRoot_ = 28

    'IShellItem
    GetDisplayName_ = 5

End Enum

Public Enum FDAP
    FDAP_BOTTOM = &H0
    FDAP_TOP = &H1
End Enum

Public Enum FILEOPENDIALOGOPTIONS
    FOS_OVERWRITEPROMPT = &H2
    FOS_STRICTFILETYPES = &H4
    FOS_NOCHANGEDIR = &H8
    FOS_PICKFOLDERS = &H20
    FOS_FORCEFILESYSTEM = &H40
    FOS_ALLNONSTORAGEITEMS = &H80
    FOS_NOVALIDATE = &H100
    FOS_ALLOWMULTISELECT = &H200
    FOS_PATHMUSTEXIST = &H800
    FOS_FILEMUSTEXIST = &H1000
    FOS_CREATEPROMPT = &H2000
    FOS_SHAREAWARE = &H4000
    FOS_NOREADONLYRETURN = &H8000
    FOS_NOTESTFILECREATE = &H10000
    FOS_HIDEMRUPLACES = &H20000
    FOS_HIDEPINNEDPLACES = &H40000
    FOS_NODEREFERENCELINKS = &H100000
    FOS_OKBUTTONNEEDSINTERACTION = &H200000
    FOS_DONTADDTORECENT = &H2000000
    FOS_FORCESHOWHIDDEN = &H10000000
    FOS_DEFAULTNOMINIMODE = &H20000000
    FOS_FORCEPREVIEWPANEON = &H40000000
    FOS_SUPPORTSTREAMABLEITEMS = &H80000000
End Enum

Public Enum FDE_SHAREVIOLATION_RESPONSE
    FDESVR_DEFAULT = &H0
    FDESVR_ACCEPT = &H1
    FDESVR_REFUSE = &H2
End Enum

Public Enum SIGDN
    SIGDN_NORMALDISPLAY = &H0
    SIGDN_PARENTRELATIVEPARSING = &H80018001
    SIGDN_DESKTOPABSOLUTEPARSING = &H80028000
    SIGDN_PARENTRELATIVEEDITING = &H80031001
    SIGDN_DESKTOPABSOLUTEEDITING = &H8004C000
    SIGDN_FILESYSPATH = &H80058000
    SIGDN_URL = &H80068000
    SIGDN_PARENTRELATIVEFORADDRESSBAR = &H8007C001
    SIGDN_PARENTRELATIVE = &H80080001
    SIGDN_PARENTRELATIVEFORUI = &H80094001
End Enum

' ----==== Type ====----
Private Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

' ----==== Kernel32.dll Deklarationen ====----
Private Declare Sub CopyMemory Lib "Kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef pDst As Any, _
                    ByRef pSrc As Any, _
                    ByVal ByteLen As Long)
                    
Private Declare Function lstrlenW Lib "Kernel32.dll" ( _
                         ByVal lpString As Long) As Long
                         
' ----==== Shell32.dll Deklarationen ====----
Private Declare Function SHCreateItemFromParsingName Lib "Shell32.dll" ( _
                         ByVal pszPath As Long, _
                         ByVal pbc As Long, _
                         ByVal riid As Long, _
                         ByRef ppv As Long) As Long
                         
' ----==== Ole32.dll Deklarationen ====----
Private Declare Sub CoTaskMemFree Lib "Ole32.dll" ( _
                    ByVal hMem As Long)
                    
Private Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                         ByVal pString As Long, _
                         ByRef pCLSID As GUID) As Long
                         
Private Declare Function CoCreateInstance Lib "Ole32.dll" ( _
                         ByVal rclsid As Long, _
                         ByVal pUnkOuter As Long, _
                         ByVal dwClsContext As Long, _
                         ByVal riid As Long, _
                         ByRef ppv As Long) As Long
                         
' ----==== Oleaut32.dll Deklarationen ====----
Private Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                         ByVal pvInstance As Long, _
                         ByVal oVft As Long, _
                         ByVal cc As Long, _
                         ByVal vtReturn As VbVarType, _
                         ByVal cActuals As Long, _
                         ByVal prgvt As Any, _
                         ByVal prgpvarg As Any, _
                         ByRef pvargResult As Variant) As Long
                         
' ----==== Variablen ====----
Private m_lngCookie As Long
Private m_pIPickFolderDialog As Long
Private m_pIFileDialogEvents As Long

' ----==== Events IFileDialogEvents ====----
Public Event OnFileOk()
Public Event OnFolderChanging(ByVal sFolder As String)
Public Event OnFolderChange()
Public Event OnSelectionChange()
Public Event OnShareViolation(ByVal sFolder As String, ByVal Response As FDE_SHAREVIOLATION_RESPONSE)
Public Event OnTypeChange()
Public Event OnOverwrite(ByVal sFolder As String, ByVal Response As FDE_SHAREVIOLATION_RESPONSE)

' ----==== Klasse ====----
Private Sub Class_Initialize()

    Dim eFODO As FILEOPENDIALOGOPTIONS

    If CoCreateInstance(VarPtr(Str2Guid(CLSID_FileOpenDialog)), 0&, _
        CLSCTX_INPROC, VarPtr(Str2Guid(IID_IFileDialog2)), _
        m_pIPickFolderDialog) <> S_OK Then
        
        Debug.Print "Fehler beim Erstellen des Interfaces!"
        
    Else
    
        If Me.GetOptions(eFODO) = True Then
    
            eFODO = eFODO Or FOS_PICKFOLDERS
        
            Call Me.SetOptions(eFODO)
    
        End If
        
        m_pIFileDialogEvents = modIFileDialogEvents.IFileDialogEvents(ObjPtr(Me))
        
        If m_pIFileDialogEvents <> 0& Then
        
             Call Advise(m_pIFileDialogEvents, m_lngCookie)
        
        End If
        
    End If

End Sub

Private Sub Class_Terminate()

    If m_pIPickFolderDialog <> 0& Then
    
        If m_pIFileDialogEvents <> 0& Then
        
            If m_lngCookie <> 0& Then
            
                Call Unadvise(m_lngCookie)
            
            End If
    
            Call CoTaskMemFree(m_pIFileDialogEvents)
    
        End If
    
        Call Release(m_pIPickFolderDialog)
        
    End If

End Sub

' ----==== IModalWindow Funktionen ====----
Public Function Show(Optional ByVal hwndOwner As Long = 0&) As Boolean

    Dim bolRet As Boolean
    Dim eFODO As FILEOPENDIALOGOPTIONS
    
    bolRet = False
    
    If m_pIPickFolderDialog <> 0& Then
    
        If Me.GetOptions(eFODO) = True Then
    
            If CBool(eFODO And FOS_PICKFOLDERS) = False Then
            
                eFODO = eFODO Or FOS_PICKFOLDERS
        
                Call Me.SetOptions(eFODO)
        
            End If
    
        End If
    
        If Invoke(m_pIPickFolderDialog, Show_, hwndOwner) = S_OK Then
    
            bolRet = True
        
        End If
    
    End If
        
    Show = bolRet
    
End Function

' ----==== IFileDialog Funktionen ====----
'    SetFileTypes_ = 4

'    SetFileTypeIndex_ = 5

'    GetFileTypeIndex_ = 6

'    Advise_ = 7
Private Sub Advise(ByVal pfde As Long, ByRef dwCookie As Long)

    If m_pIPickFolderDialog <> 0& Then

        If Invoke(m_pIPickFolderDialog, Advise_, pfde, VarPtr(dwCookie)) = S_OK Then

        End If
        
    End If

End Sub

'    Unadvise_ = 8
Private Sub Unadvise(ByRef dwCookie As Long)

    If m_pIPickFolderDialog <> 0& Then
        
        If Invoke(m_pIPickFolderDialog, Unadvise_, dwCookie) = S_OK Then

            dwCookie = 0&

        End If
        
    End If

End Sub

'    SetOptions_ = 9
Public Function SetOptions(ByVal eFODO As FILEOPENDIALOGOPTIONS) As Boolean

    Dim bolRet As Boolean
    
    bolRet = False

    If m_pIPickFolderDialog <> 0& Then

        If Invoke(m_pIPickFolderDialog, SetOptions_, eFODO) = S_OK Then

            bolRet = True

        End If
    
    End If

    SetOptions = bolRet

End Function

'    GetOptions_ = 10
Public Function GetOptions(ByRef eFODO As FILEOPENDIALOGOPTIONS) As Boolean

    Dim bolRet As Boolean
    
    bolRet = False

    If m_pIPickFolderDialog <> 0& Then

        If Invoke(m_pIPickFolderDialog, GetOptions_, VarPtr(eFODO)) = S_OK Then

            bolRet = True

        End If
    
    End If

    GetOptions = bolRet

End Function

'    SetDefaultFolder_ = 11
Public Function SetDefaultFolder(Optional ByVal sFolder As String = vbNullChar) As Boolean
    
    Dim bolRet As Boolean
    Dim pIShellItem As Long
    
    bolRet = False
    
    If m_pIPickFolderDialog <> 0& Then
    
        If SHCreateItemFromParsingName(StrPtr(sFolder), 0&, _
            VarPtr(Str2Guid(IID_IShellItem)), pIShellItem) = S_OK Then
        
            If Invoke(m_pIPickFolderDialog, SetDefaultFolder_, pIShellItem) = S_OK Then
        
                bolRet = True
            
            End If
        
            Call Release(pIShellItem)
        
        End If
    
    End If
    
    SetDefaultFolder = bolRet
    
End Function

'    SetFolder_ = 9
Public Function SetFolder(Optional ByVal sFolder As String = vbNullChar) As Boolean
    
    Dim bolRet As Boolean
    Dim pIShellItem As Long
    
    bolRet = False
    
    If m_pIPickFolderDialog <> 0& Then
    
        If SHCreateItemFromParsingName(StrPtr(sFolder), 0&, _
            VarPtr(Str2Guid(IID_IShellItem)), pIShellItem) = S_OK Then
        
            If Invoke(m_pIPickFolderDialog, SetFolder_, pIShellItem) = S_OK Then
        
                bolRet = True
            
            End If
        
            Call Release(pIShellItem)
        
        End If
    
    End If
    
    SetFolder = bolRet
    
End Function

'    GetFolder_ = 13
Public Function GetFolder(ByRef sFolder As String) As Boolean

    Dim bolRet As Boolean
    Dim pszName As Long
    Dim pIShellItem As Long
    
    bolRet = False
    
    If m_pIPickFolderDialog <> 0& Then

        If Invoke(m_pIPickFolderDialog, GetFolder_, VarPtr(pIShellItem)) = S_OK Then
    
            If Invoke(pIShellItem, GetDisplayName_, SIGDN.SIGDN_FILESYSPATH, VarPtr(pszName)) = S_OK Then
            
                bolRet = True
            
                sFolder = StrPtr2Str(pszName)
            
            End If
        
            Call Release(pIShellItem)
        
        End If
    
    End If
    
    GetFolder = bolRet
    
End Function

'    GetCurrentSelection_ = 14
Public Function GetCurrentSelection(ByRef sFolder As String) As Boolean

    Dim bolRet As Boolean
    Dim pszName As Long
    Dim pIShellItem As Long
    
    bolRet = False
    
    If m_pIPickFolderDialog <> 0& Then

        If Invoke(m_pIPickFolderDialog, GetCurrentSelection_, VarPtr(pIShellItem)) = S_OK Then
    
            If Invoke(pIShellItem, GetDisplayName_, SIGDN.SIGDN_FILESYSPATH, VarPtr(pszName)) = S_OK Then
            
                bolRet = True
            
                sFolder = StrPtr2Str(pszName)
            
            End If
        
            Call Release(pIShellItem)
        
        End If
    
    End If
    
    GetCurrentSelection = bolRet
    
End Function

'    SetFileName_ = 15

'    GetFileName_ = 16

'    SetTitle_ = 17
Public Function SetTitle(Optional ByVal sTitle As String = vbNullChar) As Boolean

    Dim bolRet As Boolean
    
    bolRet = False
    
    If m_pIPickFolderDialog <> 0& Then
    
        If Invoke(m_pIPickFolderDialog, SetTitle_, StrPtr(sTitle)) = S_OK Then

            bolRet = True

        End If
    
    End If
    
    SetTitle = bolRet

End Function

'    SetOkButtonLabel_ = 18
Public Function SetOkButtonLabel(Optional ByVal sLabel As String = vbNullChar) As Boolean

    Dim bolRet As Boolean
    
    bolRet = False
    
    If m_pIPickFolderDialog <> 0& Then
    
        If Invoke(m_pIPickFolderDialog, SetOkButtonLabel_, StrPtr(sLabel)) = S_OK Then

            bolRet = True

        End If
    
    End If
    
    SetOkButtonLabel = bolRet

End Function

'    SetFileNameLabel_ = 19
Public Function SetFileNameLabel(Optional ByVal sLabel As String = vbNullChar) As Boolean

    Dim bolRet As Boolean
    
    bolRet = False
    
    If m_pIPickFolderDialog <> 0& Then
    
        If Invoke(m_pIPickFolderDialog, SetFileNameLabel_, StrPtr(sLabel)) = S_OK Then

            bolRet = True

        End If
    
    End If
    
    SetFileNameLabel = bolRet

End Function

'    GetResult_ = 20
Public Function GetResult(ByRef sResult As String) As Boolean

    Dim bolRet As Boolean
    Dim pszName As Long
    Dim pIShellItem As Long
    
    bolRet = False
    
    If m_pIPickFolderDialog <> 0& Then

        If Invoke(m_pIPickFolderDialog, GetResult_, VarPtr(pIShellItem)) = S_OK Then
    
            If Invoke(pIShellItem, GetDisplayName_, SIGDN.SIGDN_FILESYSPATH, VarPtr(pszName)) = S_OK Then
            
                bolRet = True
            
                sResult = StrPtr2Str(pszName)
            
            End If
        
            Call Release(pIShellItem)
        
        End If
    
    End If
    
    GetResult = bolRet
    
End Function

'    AddPlace_ = 21
Public Function AddPlace(ByVal sFolder As String, ByVal eFDAP As FDAP) As Boolean
    
    Dim bolRet As Boolean
    Dim pIShellItem As Long
    
    bolRet = False
    
    If m_pIPickFolderDialog <> 0& Then
    
        If SHCreateItemFromParsingName(StrPtr(sFolder), 0&, _
            VarPtr(Str2Guid(IID_IShellItem)), pIShellItem) = S_OK Then
        
            If Invoke(m_pIPickFolderDialog, AddPlace_, pIShellItem, eFDAP) = S_OK Then
        
                bolRet = True
            
            End If
        
            Call Release(pIShellItem)
        
        End If
    
    End If
    
    AddPlace = bolRet
    
End Function

'    SetDefaultExtension_ = 22

'    Close_ = 23

'    SetClientGuid_ = 24

'    ClearClientData_ = 25

'    SetFilter_ = 26

' ----==== IFileDialog2 Funktionen ====----
'    SetCancelButtonLabel_ = 27
Public Function SetCancelButtonLabel(Optional ByVal sLabel As String = vbNullChar) As Boolean

    Dim bolRet As Boolean
    
    bolRet = False
    
    If m_pIPickFolderDialog <> 0& Then
    
        If Invoke(m_pIPickFolderDialog, SetCancelButtonLabel_, StrPtr(sLabel)) = S_OK Then

            bolRet = True

        End If
    
    End If
    
    SetCancelButtonLabel = bolRet

End Function

'    SetNavigationRoot_ = 28
Public Function SetNavigationRoot(Optional ByVal sFolder As String = vbNullChar) As Boolean
    
    Dim bolRet As Boolean
    Dim pIShellItem As Long
    
    bolRet = False
    
    If m_pIPickFolderDialog <> 0& Then
    
        If SHCreateItemFromParsingName(StrPtr(sFolder), 0&, _
            VarPtr(Str2Guid(IID_IShellItem)), pIShellItem) = S_OK Then
        
            If Invoke(m_pIPickFolderDialog, SetNavigationRoot_, pIShellItem) = S_OK Then
        
                bolRet = True
            
            End If
        
            Call Release(pIShellItem)
        
        End If
    
    End If
    
    SetNavigationRoot = bolRet
    
End Function

' ----==== Raise Events IFileDialogEvents ====----
Public Sub OnFileOk()

    RaiseEvent OnFileOk

End Sub

Public Sub OnFolderChanging(ByVal psiFolder As Long)

    Dim pszName As Long
    Dim strFolder As String

    If Invoke(psiFolder, GetDisplayName_, SIGDN.SIGDN_FILESYSPATH, VarPtr(pszName)) = S_OK Then
            
        strFolder = StrPtr2Str(pszName)
            
    End If

    RaiseEvent OnFolderChanging(strFolder)

End Sub

Public Sub OnFolderChange()

    RaiseEvent OnFolderChange

End Sub

Public Sub OnSelectionChange()

    RaiseEvent OnSelectionChange

End Sub

Public Sub OnShareViolation(ByVal psi As Long, ByVal pResponse As Long)

    Dim pszName As Long
    Dim strFolder As String

    If Invoke(psi, GetDisplayName_, SIGDN.SIGDN_FILESYSPATH, VarPtr(pszName)) = S_OK Then
            
        strFolder = StrPtr2Str(pszName)
            
    End If

    RaiseEvent OnShareViolation(strFolder, pResponse)

End Sub

Public Sub OnTypeChange()

    RaiseEvent OnTypeChange

End Sub

Public Sub OnOverwrite(ByVal psi As Long, ByVal pResponse As Long)

    Dim pszName As Long
    Dim strFolder As String

    If Invoke(psi, GetDisplayName_, SIGDN.SIGDN_FILESYSPATH, VarPtr(pszName)) = S_OK Then
            
        strFolder = StrPtr2Str(pszName)
            
    End If

    RaiseEvent OnOverwrite(strFolder, pResponse)

End Sub

' ----==== Hilfsfunktionen ====----
Private Function Invoke(ByVal pInterface As Long, _
    ByVal vtb As vtb_Interfaces, ParamArray var()) As Variant
    
    If pInterface <> 0& Then
    
        Invoke = OleInvoke(pInterface, vtb, var)
        
    End If
    
End Function

Private Sub Release(ByRef pInterface As Long)

    Dim vRet As Variant

    If pInterface <> 0& Then

        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, vbLong, _
            0&, 0&, 0&, vRet) = S_OK Then

            pInterface = 0&
            
        End If

    End If
    
End Sub

Private Function OleInvoke(ByVal pInterface As Long, _
    ByVal lCmd As Long, ParamArray aParam()) As Variant
    
    Dim lRet As Long
    Dim lItem As Long
    Dim lCount As Long
    Dim vRet As Variant
    Dim vParam As Variant
    Dim olePtr(10) As Long
    Dim oleTyp(10) As Integer

    If pInterface <> 0& Then

        If UBound(aParam) >= 0 Then

            vParam = aParam

            If IsArray(vParam) Then vParam = vParam(0)

            lCount = UBound(vParam)

            For lItem = 0 To lCount

                oleTyp(lItem) = VarType(vParam(lItem))

                olePtr(lItem) = VarPtr(vParam(lItem))

            Next

        End If
        
        lRet = DispCallFunc(pInterface, lCmd * 4, CC_STDCALL, vbLong, _
            lItem, VarPtr(oleTyp(0)), VarPtr(olePtr(0)), vRet)

        If lRet <> S_OK Then
            
            vRet = lRet
            
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"

        End If

    End If

    OleInvoke = vRet

End Function

Private Function Str2Guid(ByVal str As String) As GUID

    Call CLSIDFromString(StrPtr(str), Str2Guid)
    
End Function

Private Function StrPtr2Str(ByVal lpStrPointer As Long) As String

    Dim lLen As Long
    Dim bBuffer() As Byte

    If lpStrPointer = 0 Then Exit Function

    lLen = lstrlenW(lpStrPointer) * 2& - 1&

    If lLen > 0& Then

        ReDim bBuffer(lLen)

        Call CopyMemory(bBuffer(0), ByVal lpStrPointer, lLen)
        
        Call CoTaskMemFree(lpStrPointer)

        StrPtr2Str = bBuffer

    End If

End Function

